<!--https://github.com/nkreiger/vue-canvas/blob/master/src/components/Canvas.vue-->
<template>
  <div>
    <canvas ref="canvasId" class="canvas-style" @mousedown="mouseDown" resize/>
  </div>
  <div>
    <button @click="reset">Reset</button>
  </div>

</template>

<script setup>
import {ref, onMounted} from 'vue';
import paper from 'paper';

const familyType = useFamilyTypeStore()

const path = ref(null);
const scope = ref(new paper.PaperScope());
const canvasId = ref(null);
let tool = null;

let hitOptions = {
  segments: true,
  stroke: true,
  fill: true,
  tolerance: 5
};

const reset = () => {
  scope.value.project.activeLayer.removeChildren();
  //paper.project.activeLayer.removeChildren(); //das cleart einfach auf die simplepaperjsintegration
};

const pathCreate = (scope) => {
  scope.activate();
  return new paper.Path({
    strokeColor: '#000000',
    strokeJoin: 'round',
    strokeWidth: 5,
  });
};

const createTool = (scope) => {
  scope.activate();
  return new paper.Tool();
};

const mouseDown = () => {
  // in order to access functions in nested tool

  // create drawing tool
  tool = createTool(scope.value);

  tool.onMouseDown = (event) => {
    // init path
    path.value = pathCreate(scope.value);
    // add point to path
    path.value.add(event);
  };
  tool.onMouseDrag = (event) => {
    console.log(event)
    path.value.add(event);
  };
  tool.onMouseUp = (event) => {
    console.log(event)
    // line completed
    path.value.add(event);
  };
};

onMounted(() => {
  scope.value.setup(canvasId.value);
});
</script>

<style scoped>
@import '../../main.css';
</style>